class MyStringBuilder 
{
    public static void main(String[] args) 
    {
        System.out.println("Hello World!");
    }
}
/*C create U update R read D delete

*/
class StringWorker 
{
    private char[] value;
    private int count;
    private transient char[] toStringCache;
    StringWorker(){
        value=new char[16];
    }
    StringWorker(int len){
        value=new char[len];
    }
    StringWorker(String str){
        ensureLen(str.length()+16);
        append(str);
    }
    StringWorker(CharSequence seq){
        this(seq.toString());
    }

    public void trimToSize() {
        if (count < value.length) {
            value = copyArr(value, count);
        }
    }
    public void ensureLen(int minLen) {
        if(minLen<=0 || minLen<=value.length)
            return;
        int newLen = (value.length<<1) + 2;
        if(newLen<minLen)
            newLen=minLen;
        if(newLen<0)
            newLen = Integer.MAX_VALUE;
        value = copyArr(value, newLen);
    }
    public char[] copyArr(char[] src,int count){
        return copyArr(src,0,count);
    }
    public char[] copyArr(char[] src,int offse,int end){
        int len=end-offse;
        char[] result=new char[len];
        arraycopy(Object src, int srcPos, Object dest, int destPos, int length)
        return result;
    }
/*1洢
	StringBuffer append():ָΪӵݽβ
	StringBuffer insert(index,):Խݲ뵽ָindexλá
*/
    public StringWorker append(Object obj) {
        return append(String.valueOf(obj));
    }
    public StringWorker append(String str) {
        if (str == null)
            return this;
        int len = str.length();
        ensureLen(count + len);
        str.getChars(0, len, value, count);
        count += len;
        return this;
    }
    public StringWorker append(char c) {
        ensureLen(count + 1);
        value[count++] = c;
        return this;
    }
    public StringWorker append(char[] str) {
        return append(str,0,str.length);
    }
    public StringWorker append(char str[], int offset, int len) {
        if (len > 0)
            ensureLen(count + len);
        System.arraycopy(str, offset, value, count, len);
        count += len;
        return this;
    }
    public StringWorker append(int i) {
        return append(Integer.toString(i));
    }
    public StringWorker insert(int index, char[] str, int offset,int len) {
        if ((index < 0) || (index > length()))
            throw new StringIndexOutOfBoundsException(index);
        if ((offset < 0) || (len < 0) || (offset > str.length - len))
            throw new StringIndexOutOfBoundsException(
                "offset " + offset + ", len " + len + ", str.length "
                + str.length);
        ensureLen(count + len);
        System.arraycopy(value, index, value, index + len, count - index);
        System.arraycopy(str, offset, value, index, len);
        count += len;
        return this;
    }
    public StringWorker insert(int offset, String str) {
        if (str == null)
            str = "null";
        int len = str.length();
        if(len==0)
            return this;
        return insert(offset,str.toCharArray(),0,len);
    }
    public StringWorker insert(int offset, Object obj) {
        return insert(offset, String.valueOf(obj));
    }
    public StringWorker insert(int offset, char c) {
        ensureLen(count + 1);
        System.arraycopy(value, offset, value, offset + 1, count - offset);
        value[offset] = c;
        ++count;
        return this;
    }
    /*
    2ɾ
	StringBuffer delete(start,end):ɾеݣstartend
	StringBuffer deleteCharAt(index):ɾָλõַ*/
    public StringWorker delete(int start, int end) {
        if (start < 0)
            throw new StringIndexOutOfBoundsException(start);
        if (end > count)
            end = count;
        if (start > end)
            throw new StringIndexOutOfBoundsException();
        int len = end - start;
        if (len > 0) {
            System.arraycopy(value, start+len, value, start, count-end);
            count -= len;
        }
        return this;
    }
    public StringWorker deleteCharAt(int index) {
        return delete(index,index+1);
    }
/* 
3ȡ
	char charAt(int index) 
	int indexOf(String str) 
	int lastIndexOf(String str)
	int length() 
	String substring(int start, int end) 
    getChars(int srcBegin, int srcEnd, char[] dst, int dstBegin)
*/
    public char charAt(int index) {
        if ((index < 0) || (index >= count))
            throw new StringIndexOutOfBoundsException(index);
        return value[index];
    }
     public int indexOf(String str) {
        return indexOf(str, 0);
    }
    public int indexOf(String str, int fromIndex) {
        return String.indexOf(value, 0, count, str, fromIndex);
    }
    public int lastIndexOf(String str) {
        return String.lastIndexOf(value, 0, count, str, 0);
    }
    public int lastIndexOf(String str, int fromIndex) {
        return String.lastIndexOf(value, 0, count, str, fromIndex);
    }
    public int length() {
        return count;
    }
    public String substring(int start, int end) {
        if (start < 0)
            throw new StringIndexOutOfBoundsException(start);
        if (end > count)
            throw new StringIndexOutOfBoundsException(end);
        if (start > end)
            throw new StringIndexOutOfBoundsException(end - start);
        return new String(value, start, end - start);
    }
    public String substring(int start) {
        return substring(start, count);
    }
    public void getChars(int srcBegin, int srcEnd, char[] dst, int dstBegin){
        if (srcBegin < 0)
            throw new StringIndexOutOfBoundsException(srcBegin);
        if ((srcEnd < 0) || (srcEnd > count))
            throw new StringIndexOutOfBoundsException(srcEnd);
        if (srcBegin > srcEnd)
            throw new StringIndexOutOfBoundsException("srcBegin > srcEnd");
        System.arraycopy(value, srcBegin, dst, dstBegin, srcEnd - srcBegin);
    }
    /*
    4޸ġ
	StringBuffer replace(start,end,string);
	void setCharAt(int index, char ch) ;
	StringBuffer reverse();//ת
    */
    public StringWorker replace(int start, int end, String str) {
        if (start < 0)
            throw new StringIndexOutOfBoundsException(start);
        if (start > count)
            throw new StringIndexOutOfBoundsException("start > length()");
        if (start > end)
            throw new StringIndexOutOfBoundsException("start > end");

        if (end > count)
            end = count;
        int len = str.length();
        int newCount = count + len - (end - start);
        ensureLen(newCount);

        System.arraycopy(value, end, value, start + len, count - end);
        str.getChars(value, start);
        count = newCount;
        return this;
    }
    public void setCharAt(int index, char ch) {
        if ((index < 0) || (index >= count))
            throw new StringIndexOutOfBoundsException(index);
        value[index] = ch;
    }
    public StringWorker reverse() {
        for(int i=0,int j=count-1;i<j;i++,j--)
            swap(value,i,j);
    }
    private static void swap(char[] ch,int i,int j)
    {
        char temp=ch[i];
        ch[i]=ch[j];
        ch[j]=temp;
    }
}
